# Änderungen am Basisregelwerk
Im generellen belege ich alles auf dem Basisregelwerk, welches hier schnell eingesehen werden kann; [Crobis quickref](https://crobi.github.io/dnd5e-quickref/preview/quickref.html) 

Ich versuche mich daran zu halten, diese Regelungen so gut wie möglich ein zu halten.

## Regelablauf
Der GM geht von fairem verhalten der Spieler aus.
Ich erlaube ebenfalls leichte Regelverbiegungen. Diese sind aber meist einmalig 

## Exhaustion

### Orte mit Exhaustion
Es gibt spezifische Orte an welchen die Exhaustion stärker ausschlägt. Die Rede dabei ist von Extrem Gebieten wie beispielsweise eine Wüste, in welcher es über die Dauer der Nacht trotzdem zu einer extremen Kälte kommen kann. Jeh nach ausrüstung kann dann trotzdem eine Exhaustion getriggert werden. Informationen zum richtigen ausharren in den jeweiligen Wildgebieten können von den Einheimischen eingeholt werden.

## Pistolen
Misfire kann immernoch gleich triggern wie immer. ABER wenn man sich mit einer Waffe Attuned (Durch Waffentraining für einen Tag) so kann man den Misfire stat ignorieren

## Death Saves

Jegliche Abilities welche die “Save Checks” manipulieren funktionieren auch in den Death Saves. Death Saves sind privat an den GM zu rollen, weder der Spieler, noch die Truppe wissen dann, welches Unheil den Spieler erwarten. (Und nicht Linsen bei dem Character Sheet ^^)

## Weniger bekannte Möglichkeiten

### Bewegung
Im PHB (Englisch), Seite. 190. Steht, dass das Überqueren einer Kreatur jeweils difficult terrain ist. Auch können nicht-hostile Plätze automatisch (ohne fragen) überquert werden. Dies kann vom Spieler, der gerade "überquert" wird aber mit einer Reaction abgefangen werden, solange noch keine Würfel Aktion durchgeführt wurde.

### Zauberklassen (Hinweis)
Ihr könnt eure Spells auch mit einer Ready Action benutzen! Das benötigt aber Concentration und der Spell darf maximal eine Casting Time von einer Action haben.

### Death Saves (Hinweis)
Wird man in den Death Saves angegriffen, so wird mit Advantage angegriffen. Treffer addieren einen negativen Punkt zum death save.

## Hausregeln
| Nr. | Name                   | Beschreibung                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
|:---:|:-----------------------|:---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|  1  | Kenkus                 | Kenkus müssen leider draussen bleiben. Die sind zwar eine geniale Rasse, aber funktionieren nicht fürs Roleplay.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
|  2  | Rassen                 | Im generellen gehe ich von den 9 Standard 5E Rassen aus, ohne Zusatzinhalt. Man kann mich gerne daran überzeugen, dass diese Rasse unbedingt genommen werden muss, weil sie “oh doch so perfekt zu dem Charakter passen”. (Standardmässig, mach einfach einen anderen.) Ebenfalls dürfen keine Rassen genommen werden, welche fliegen können. Ich erlaube aber [diese Klasse](https://homebrewery.naturalcrit.com/share/Hyj68ZHhM), weil sie toll ist. Begründung: Da dies ein komplettes BUCH wird als DND, wird es schwierig für alle Klassen eine spassige Inszenierung darzustellen. Ich gehe von einer Party of 4 aus. Das bedeutet, dass ich von einem Fighter, einem Barbarian, einem Druid und einem Rogue. Alle haben einen +1 Modifier auf allen Ability Scores. |
|  3  | Party splitting        | Es kann durchaus mal vorkommen, dass die Party gesplittet wird. Das ist unabdingbar, aber nervig. Bitte habt geduld mit der subparty oder nutzt das Modul "Walkie Talkie". Ich werde noch darauf eingehen, wie das genutzt wird.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
|  4  | Der GM hat immer Recht | Und sollte er mal nicht recht haben, so ist das dem GM egal. (Ich hatte die Ehre, ihn selbst zu fragen!) Scherz beiseite, WENN mal irgendwas nicht stimmt, so bitte ich euch den Regelbruch oder was auch immer aufzuschreiben und am ENDE der Runde beizutragen. Ich kenn bedauerlicherweise nicht das ganze Regelwerk auswendig.                                                                                                                                                                                                                                                                                                                                                                                                                                         |
|  5  | PC Wechsel             | Ich sags schon mal vorab, ihr kommt von dem Hauptort nicht so einfach weg in ein anderes Land. Wenn ihr euren PC aufgebt und ihn “Cool in den Sonnenuntergang reiten” lässt, sodass ihr einen neuen Character erstellen könnt, so wird dieser den Fluch der unendlich fallenden Steine erleiden (50d100 stupidity damage, dagegen könnt ihr nicht mal resistent sein!)                                                                                                                                                                                                                                                                                                                                                                                                     |
|  6  | Charakter erstellung   | Bei der Charaktererstellung gibt es für euch die Möglichkeit, stärker zu sein, als sonst! Es gilt folgendes Vorgehen:  Es werde 4 Monopoly Würfel gewürfelt JEDER Würfel, welcher eine 1 zeigt, kann neu geworfen werden. Jetzt entfernt man den niedrigsten Würfel Nun rechnet man alles zusammen                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
|  7  | Inspiration            | Ihr werdet über die Sessions hinweg inspiriert, jedoch funktioniert die Inspiration nicht einfach als Notlösung, wenn ihr mal eine 1 gewürfelt habt. Benutzt ihr eure Inspiration, so wird der gewünschte Wurf, auf welchen ihr Inspiration verwendet automatisch eine NAT 20. Dies geht NICHT bei death saves, dort kann nur der misslungene Wurf neu gerollt werden.                                                                                                                                                                                                                                                                                                                                                                                                     |
|  8  | Spelländerungen        | Wenn Ihr eure Spells für eure Klasse Ändern wollt, so ist das JEDERZEIT möglich, sofern Ihr euch für einen halben Tag in einer euch Nahen “Bildungseinrichtung” sitzt. Das “Umlernen” benötigt concentration. Folgende Möglichkeiten sind akzeptabel:  Artificer -> Schmiede Bard -> Taverne Cleric -> Kirche Druid -> Beim Trankhändler Paladin -> In den Trainingshallen Ranger -> Im Wald Sorcerer ->  Warlock -> Irgendwo, wo sie mit ihrem Dämonen alleine sind. Wizard -> Bibliotheke                                                                                                                                                                                                                                                                                |